// =======================================
// Web Query Catalog DDL for Informix IDS MultiPlatform
// 
// Version 1.1 - Changed STORE_TABLE.OBJECT column type 
//               from CHAR(3500) to TEXT 
// =======================================


CREATE TABLE WQ.INDEX_TABLE
(
	CREATEDTS DATETIME YEAR TO FRACTION NOT NULL,
	CREATEDIX SMALLINT NOT NULL,
	CREATOR CHAR(32) NOT NULL, 
	NAME CHAR(128) NOT NULL, 
	DESCRIPTION CHAR(255), 
	CATEGORY CHAR(32) NOT NULL,
	VERSION SMALLINT NOT NULL, 
	TYPE SMALLINT NOT NULL, 
	PUB SMALLINT NOT NULL, 
	CREATEDBY CHAR(32) NOT NULL, 
	PRIMARY KEY (CREATEDTS, CREATEDIX) 
);
    
CREATE UNIQUE INDEX WQ.INDEX_I2
    ON WQ.INDEX_TABLE
(
 	CREATOR,
	NAME,
	TYPE
);

CREATE TABLE WQ.STORE_TABLE
(
	CREATEDTS DATETIME YEAR TO FRACTION NOT NULL,
	CREATEDIX SMALLINT NOT NULL,
	SEQUENCE INTEGER NOT NULL, 
	OBJECT TEXT NOT NULL,

	FOREIGN KEY (CREATEDTS, CREATEDIX)
		REFERENCES WQ.INDEX_TABLE ON DELETE CASCADE
);

CREATE UNIQUE INDEX WQ.INDEX_I3
    ON WQ.STORE_TABLE
(
 	CREATEDTS,
	CREATEDIX,
	SEQUENCE
);

CREATE TABLE WQ.SMTP
(
	EMAIL CHAR(80) NOT NULL,
	USRNAME CHAR(20) NOT NULL,
	PASSWD CHAR(50),
	AUTHDATE DATETIME YEAR TO FRACTION,

	PRIMARY KEY (EMAIL)
);
