<?xml version="1.0" encoding="ISO-8859-1"?>

<!-- XSLT stylesheet template to invert the rows and columns
	within a data element, and pass all others through.
-->
<!-- $Id$ -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0"
  >

  <!-- Default rule: copies all unknown tags. -->
  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="/">
    <xsl:apply-templates/>
    <xsl:text>&#10;</xsl:text>
  </xsl:template>

  <!-- Rules to match rows and columns. -->
  <xsl:template match="RESULTS">
    <RESULTS>
      <xsl:text>&#10;</xsl:text>
      <xsl:call-template name="docol">
	<xsl:with-param name="col" select="1"/>
	<xsl:with-param name="ncols" select="count(ROW[1]/COL)"/>
      </xsl:call-template>
    </RESULTS>
    <xsl:text>&#10;</xsl:text>
  </xsl:template>

  <xsl:template name="docol">
    <xsl:param name="col"/>
    <xsl:param name="ncols"/>
    <xsl:if test="$ncols >= $col">
      <xsl:text>  </xsl:text>
      <ROW name="{ROW[1]/COL[$col]/@name}">
	<xsl:text>&#10;</xsl:text>
	<xsl:apply-templates select="ROW">
	  <xsl:with-param name="col" select="$col"/>
	</xsl:apply-templates>
	<xsl:text>  </xsl:text>
      </ROW>
      <xsl:text>&#10;</xsl:text>
      <xsl:call-template name="docol">
	<xsl:with-param name="col" select="$col + 1"/>
	<xsl:with-param name="ncols" select="$ncols"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

  <xsl:template match="ROW">
    <xsl:param name="col"/>
    <xsl:text>    </xsl:text>
    <COL name="{@name}">
      <xsl:if test="@color != ''">
	<xsl:attribute name="color">
	  <xsl:value-of select="@color"/>
	</xsl:attribute>
      </xsl:if>
      <xsl:value-of select="COL[$col]/text()"/>
    </COL>
    <xsl:text>&#10;</xsl:text>
  </xsl:template>

</xsl:stylesheet>
