<?xml version="1.0" encoding="ISO-8859-1"?>

<!-- XSLT stylesheet template fragment:
	Creates a legend describing items in a graph.
-->
<!-- $Id$ -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0"
  >

  <xsl:template match="legend">
    <xsl:text>  </xsl:text>
    <svg x="80" y="10" width="20" height="90" viewBox="0 0 50 100"
	 preserveAspectRatio="none" stroke-width="0.2" font-size="5"
	 text-anchor="start">
      <xsl:text>&#10;</xsl:text>
      <xsl:apply-templates/>
    <xsl:text>  </xsl:text>
    </svg>
    <xsl:text>&#10;</xsl:text>
  </xsl:template>

  <xsl:template match="item">
    <xsl:text>    </xsl:text>
    <g transform="translate(2,{position()*7})">
      <xsl:text>&#10;      </xsl:text>
      <xsl:choose>
	<xsl:when test="@type = 'line'">
	  <path d="M 0,0 L 4,-4" stroke="{@color}" fill="none"
		stroke-width="1"/>
	</xsl:when>
	<xsl:when test="@type = 'pie'">
	  <path d="M 0,0 v -3 A 4 2 0 0 1 4 -2 Z" fill="{@color}" stroke="black"/>
	</xsl:when>
	<xsl:otherwise>
	  <path d="M 0,0 v -4 h 4 v 4 Z" fill="{@color}" stroke="black"/>
	</xsl:otherwise>
      </xsl:choose>
      <xsl:text>&#10;      </xsl:text>
      <text x="7" y="0">
	<xsl:apply-templates/>
      </text>
      <xsl:text>&#10;    </xsl:text>
    </g>
    <xsl:text>&#10;</xsl:text>
  </xsl:template>

</xsl:stylesheet>
