<?xml version="1.0" encoding="ISO-8859-1"?>

<!-- XSLT stylesheet template to turn the first column of data into
	labels for each row of data.  It places the content of the
	first column into the "name" attribute of each row, and
	removes the first column from each row.
-->
<!-- $Id$ -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0"
  >

  <!-- Default rule: copies all unmatched tags. -->
  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

  <!-- Match the root node, so that we can append a final newline. -->
  <xsl:template match="/">
    <xsl:apply-templates/>
    <xsl:text>&#10;</xsl:text>
  </xsl:template>

  <!-- Put the name attribute onto each row, and remove the first column. -->
  <xsl:template match="ROW">
    <ROW name="{COL[1]/text()}">
      <!-- This test accounts for whitespace node before the first column. -->
      <xsl:choose>
	<xsl:when test="name(./node()[1]) = ''">
	  <xsl:apply-templates select="./node()[position()>2]"/>
	</xsl:when>
	<xsl:otherwise>
	  <xsl:apply-templates select="./node()[position()>1]"/>
	</xsl:otherwise>
      </xsl:choose>
    </ROW>
  </xsl:template>

</xsl:stylesheet>
