<?xml version="1.0" encoding="ISO-8859-1"?>
 
<!-- XSLT stylesheet template to convert XML containing a result set
	into XML.  This is done by simply outputting only the RESULTS
	element, and any ROW elements and their decendents.
 -->
<!-- $Id$ -->

<!-- Declare the stylesheet. -->
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0"
  >

<!-- Declare the output method: XML. -->
  <xsl:output method="xml" indent="yes"
              omit-xml-declaration="no"
              version="1.0"
              encoding="UTF-8" />
  <xsl:strip-space elements="*"/>

  <!-- Main template: matches the RESULTS document element. -->
  <xsl:template match="/RESULTS">
    <xsl:copy>
      <!-- Only copy the rows. -->
      <xsl:text>&#10;</xsl:text>
      <xsl:apply-templates select="/RESULTS/ROW"/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="/RESULTS/ROW">
    <xsl:text> </xsl:text>
    <xsl:copy>
      <xsl:text>&#10;</xsl:text>
      <xsl:apply-templates select="@*|node()"/>
      <xsl:text> </xsl:text>
    </xsl:copy>
    <xsl:text>&#10;</xsl:text>
  </xsl:template>

  <!-- If any columns do not have a NAME attribute, then the element
	name is the name of the column or in the COLDEF element, so
	we rewrite it as a COL element with a NAME attribute.
    -->
  <xsl:template match="/RESULTS/ROW/*">
    <xsl:text>  </xsl:text>
    <xsl:choose>
      <xsl:when test="boolean(@name)">
	<xsl:copy>
	  <xsl:apply-templates select="@*|node()"/>
	</xsl:copy>
      </xsl:when>
      <xsl:when test="name() = 'COL' and
			not(boolean(/RESULTS/COLDEF/COL[@name='COL']))">
	<xsl:variable name="pos" select="position() - 1"/>
	<COL name="{/RESULTS/COLDEF/COL[$pos]/@name}">
	  <xsl:apply-templates select="@*|node()"/>
	</COL>
      </xsl:when>
      <xsl:otherwise>
	<COL name="{name()}">
	  <xsl:apply-templates select="@*|node()"/>
	</COL>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text>&#10;</xsl:text>
  </xsl:template>

  <!-- Outputs all the data, including the columns. -->
  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
