<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<%@ page import="com.rocketsoftware.util.MsgMgr" %>
<%@ page import="java.util.*,com.ibm.db2.cwq.util.*" %>
<%@ page import="com.ibm.db2.cwq.util.UserConnection" %>
<%@ page import="com.ibm.db2.cwq.msgs.JspTablePropPage" %>

<jsp:useBean id="webquerytool_cfg" class="com.ibm.db2.cwq.util.Config" scope="session"/>
<jsp:useBean id="webquerytool_user" class="com.ibm.db2.cwq.util.User" scope="session"/>
<jsp:useBean id="webquerytool_ui" class="com.ibm.db2.cwq.util.UI" scope="session"/>
<jsp:useBean id="webquerytool_tv" class="com.rocketsoftware.datautil.TableView" scope="session"/>

<%
    response.setHeader("Pragma", "No-cache");
    response.setHeader("Cache-Control", "no-cache");
    response.setDateHeader("Expires",0);

	MsgMgr msgMgr = new MsgMgr(
		"com.ibm.db2.cwq.nls.TablePropPageJSP",
		request.getLocale()
	);

	MsgMgr headerMsgMgr = new MsgMgr(
		"com.ibm.db2.cwq.nls.HeaderPageJSP",
		request.getLocale()
	);

	UserConnection uc = webquerytool_user.getConnection(
		webquerytool_user.getCurrentCon()
	);

	JspTablePropPage jspInfo = new JspTablePropPage();
	jspInfo.setLoc( request.getLocale() );
	
	// -----------------------------------------
	// Get the grant information from the server.
    String[] privgrantees = webquerytool_tv.getPrivGrantees();
    String[] grantoption = webquerytool_tv.getGrantOption();
%>

<!-- All rights reserved. Licensed Materials Property of IBM          -->
<!-- Note to US Government users                                      -->
<!-- Documentation related to restricted rights                       -->
<!-- Use, duplication or disclosure is subject to restrictions        -->
<!-- set forth in GSA ADP Schedule with IBM Corp.                     -->
<!--This page may contain other proprietary notices and copyright     -->
<!--information, the terms of which must be observed and followed.    -->

<HTML>

<head>
	<title> <%= msgMgr.get( "CWQJspTablePropPage_Title" ) %> </title>

	<base href="<%= webquerytool_cfg.getWebRoot(request) %>">

	<META name="COPYRIGHT"
		  content="IBM Corporation (c) 1999-2002, All Rights Reserved">
	<META name="GENERATOR"
		  content="IBM Web Query Tool (c) 1999-2002, All Rights Reserved">

	<SCRIPT language="JavaScript" src="webquery.js">
	</SCRIPT>

<SCRIPT language="JavaScript">
<!--
    permId = new Array();	// Grantee array.
    permOpt = new Array();	// Grant option array.
    num = new Array();

<%  for( int i=0; i<8; i++ )
    {
		String[] priv_elem = WQUtil.split( privgrantees[i], ";" );
		String[] gopt_elem = WQUtil.split( grantoption[i], ";" );
%>
	permId[<%=i%>] = new Array();
	permOpt[<%=i%>] = new Array();
	num[<%=i%>] = <%= priv_elem.length %>;
<% 		for( int j=0; j<priv_elem.length; j++ ) { %>
			permId[<%=i%>][<%=j%>] = "<%= priv_elem[j] %>";
			permOpt[<%=i%>][<%=j%>] = "<%= gopt_elem[j] %>";
<% 		} %>
<%	} %>

    // New arrays for the update msg.
    grantId = new Array();		// The grantees that are newly granted with privilges.
    grantPriv = new Array();	// The privileges that are newly granted.
    //var grantNumber = 0;		// The number of the new grantees.

    revokeId = new Array();		// The sql ids that are newly revoked with privileges.
    revokePriv = new Array();	// The privileges that are newly revoked.
    //var revokeNumber = 0;		// The number of the new revokees.

    var checkIfChanged = false;		// Check if any change in table properties has been made.
    var commentChanged = false;		// Check if the table description has changed.


	// ----------------------------------------------
	// changecomment()
	// ----------------------------------------------

	function changecomment()
	{
	    commentChanged = true;
	    checkIfChanged = true;
	    return;
	}


	// ----------------------------------------------
	// displayGrantee()
	// updage the grantee list with current auth
	// holders for the selected priv.
	// ----------------------------------------------

	function displayGrantee()
	{
		// clear the list
		document.mainform.grantList.options.length = 0;

	    // get the selected priv
	    var sel = document.mainform.privList.selectedIndex;

	    // see how many are selected
	    var selcount = 0;
	    for( var i=0; i<document.mainform.privList.length; i++ )
		{
			if( document.mainform.privList[i].selected )
				selcount++;
		}

		// if only one selected and all is not selected
		if( selcount == 1 && sel != 6 )
		{
			var tmpGrantee;
			sel = document.mainform.privList.options[sel].value;

			//document.mainform.grantList.options.length = num[sel];

			for( var j=0; j<permId[sel].length; j++ )
			{
				tmpGrantee = permId[sel][j];
				if( permOpt[sel][j] == "YES" )
					tmpGrantee += " (G)";

				document.mainform.grantList[j] =
					new Option( tmpGrantee, tmpGrantee, false, false );
			}
		}

		document.mainform.grantList.selectedIndex = 0;
	}


	// ----------------------------------------------
	// addSqlId()
	// take a new id and place it in the idList
	// ----------------------------------------------

	function addSqlId()
	{
	    if( document.mainform.newid.value.length < 1 )
	    {
			alert( "<%= msgMgr.get( "validId" ) %>");
			return;
	    }

	    var addid = (document.mainform.newid.value).toUpperCase();

	    document.mainform.idList.options[document.mainform.idList.length] =
	    	new Option(addid, addid, false, true);

		document.mainform.idList.selectedIndex = document.mainform.idList.length-1;
	    document.mainform.newid.value = "";
	}


	// ----------------------------------------------
	// changeSqlId()
	// sync the idList to the currently selected
	// id from the grantList
	// ----------------------------------------------

	function changeSqlId()
	{
	    if( document.mainform.grantList.selectedIndex == -1 )
	    	return;

	    var sgname = document.mainform.grantList[document.mainform.grantList.selectedIndex].value;

	    for( var i=0; i<document.mainform.idList.length; i++ )
	    {
			var sqlid = document.mainform.idList[i].value;

			if( sgname.indexOf(sqlid) != -1 )
			{
				document.mainform.idList.selectedIndex = i;
				return;
			}
	    }
	}


	// ----------------------------------------------
	// grantToId()
	// ----------------------------------------------

	function grantToId()
	{
	    // --------------------------------------------------
	    // Determine which sqlid is selected
	    var selidlist = document.mainform.idList;
	    var selid = selidlist[selidlist.selectedIndex].text;

		//alert(
		//	"grantId=" +grantId + "\n" +
		//	"grantPriv=" +grantPriv + "\n" +
		//	"revokeId=" +revokeId + "\n" +
		//	"revokePriv=" +revokePriv + "\n"
		//);

	    // --------------------------------------------------
		// Cycle through all privs
		for( var ap=0; ap<document.mainform.privList.length-1; ap++ )
		{
			var apindex = document.mainform.privList[ap].value;

			if( document.mainform.privList[ap].selected
				|| document.mainform.privList[6].selected )
			{
				// --------------------------------------------------
				// priv is selected or all selected

				// --------------------------------------------------
				// update the permId list. Add the new priv if
				// necessary.
				var existspos = -1;
				for( var i=0; i<permId[apindex].length; i++ )
				{
					if( permId[apindex][i] == selid )
					{
						existspos = i;
						break;
					}
				}

				if( existspos == -1 )
					existspos = permId[apindex].length;

				permId[apindex][existspos] = selid;
				permOpt[apindex][existspos] = "NO";
				if( document.mainform.grantOption.checked )
					permOpt[apindex][existspos] = "YES";


				// --------------------------------------------------
				// Remove from revoke
				var newrevokeId = new Array();
				var newrevokePriv = new Array();
				var found = false;
				for( var i=0; i<revokeId.length; i++ )
				{
					if( revokeId[i].indexOf(selid) != -1
						&& revokePriv[i].indexOf(document.mainform.privList[ap].text) != -1
					)
					{
						found = true;
					}
					else
					{
						newrevokeId[newrevokeId.length] = revokeId[i];
						newrevokePriv[newrevokePriv.length] = revokePriv[i];
					}
				}

				revokeId = newrevokeId;
				revokePriv = newrevokePriv;

				// --------------------------------------------------
				// add to grant
				var add = -1;
				for( var i=0; i<grantId.length; i++ )
				{
					if( grantId[i].indexOf(selid) != -1
						&& grantPriv[i].indexOf(document.mainform.privList[ap].text) != -1 )
					{
						add = i;
						break;
					}
				}

				if( add == -1 )
					add = grantId.length;

				grantId[add] = selid;
				grantPriv[add] = document.mainform.privList[ap].text;
				if( document.mainform.grantOption.checked )
					grantId[add] += " WITH GRANT OPTION";
			}
		}

		displayGrantee();
	}


	// ----------------------------------------------
	// revokeFromId()
	// ----------------------------------------------

	function revokeFromId()
	{
	    // --------------------------------------------------
	    // Determine which sqlid is selected
	    var selidlist = document.mainform.idList;
	    var selid = selidlist[selidlist.selectedIndex].text;

		//alert(
		//	"grantId=" +grantId + "\n" +
		//	"grantPriv=" +grantPriv + "\n" +
		//	"revokeId=" +revokeId + "\n" +
		//	"revokePriv=" +revokePriv + "\n"
		//);

	    // --------------------------------------------------
		// Cycle through all privs
		for( var ap=0; ap<document.mainform.privList.length-1; ap++ )
		{
			var apindex = document.mainform.privList[ap].value;

			if( document.mainform.privList[ap].selected
				|| document.mainform.privList[6].selected )
			{
				// --------------------------------------------------
				// priv or all selected

				// --------------------------------------------------
				// remove it from perm list
				var newpermId = new Array();
				var newpermOpt = new Array();
				for( var i=0; i<permId[apindex].length; i++ )
				{
					if( permId[apindex][i].indexOf(selid) == -1 )
					{
						// save the id
						newpermId[newpermId.length] = permId[apindex][i];
						newpermOpt[newpermOpt.length] = permOpt[apindex][i];
					}
				}

				permId[apindex] = newpermId;
				permOpt[apindex] = newpermOpt;


				// -----------------------------------------------
				// remove from grant
				var newgrantId = new Array();
				var newgrantPriv = new Array();
				var found = false;
				for( var i=0; i<grantId.length; i++ )
				{
					if( grantId[i].indexOf(selid) != -1
						&& grantPriv[i].indexOf(document.mainform.privList[ap].text) != -1
					)
					{
						found = true;
					}
					else
					{
						newgrantId[newgrantId.length] = grantId[i]
						newgrantPriv[newgrantPriv.length] = grantPriv[i];
					}
				}

				grantId = newgrantId;
				grantPriv = newgrantPriv;

				// -----------------------------------------------
				// add to revoke
				var add = -1;
				for( var i=0; i<revokeId.length; i++ )
				{
					if( revokeId[i].indexOf(selid) != -1
						&& revokePriv[i].indexOf(document.mainform.privList[ap].text) != -1 )
					{
						add = i;
						break;
					}
				}

				if( add == -1 )
					add = revokeId.length;

				revokeId[add] = selid;
				revokePriv[add] = document.mainform.privList[ap].text;
			}
		}

		displayGrantee();
	}


	// ----------------------------------------------
	// update()
	// Prepare the privs and submit the form to the
	// servlet.
	// ----------------------------------------------

	function update()
	{
		//alert(
		//	"grantId=" +grantId + "\n" +
		//	"grantPriv=" +grantPriv + "\n" +
		//	"revokeId=" +revokeId + "\n" +
		//	"revokePriv=" +revokePriv + "\n"
		//);

	    if( grantId.length == 0 && revokeId.length == 0 && !commentChanged )
	    {
			alert( "<%= msgMgr.get( "noChange" ) %>" );
			return;
		}

		var msg = "<%= msgMgr.get( "update" ) %>" +"\n";

		for( var i=0; i<grantId.length; i++ )
		{
			if( i == 0 )
				msg += "GRANT" +"\n";

			msg += "\t" + grantPriv[i] + ' = ' + grantId[i] +"\n";
		}

		for( var j=0; j<revokeId.length; j++ )
		{
			if( j == 0 )
				msg += "REVOKE" +"\n";

			msg += "\t" +revokePriv[j] + ' = ' + revokeId[j] +"\n";
		}

		if( commentChanged )
			msg += "\n" +"<%= msgMgr.get( "changeDesc" ) %>" +"\n";

		if( confirm(msg) )
		{
			var granteeString = "";
			var grantPrivString = "";
			var revokeeString = "";
			var revokePrivString = "";

			for( var i=0; i<grantId.length; i++ )
			{
				granteeString += grantId[i] + ";";
				grantPrivString += grantPriv[i] + ";";
			}
			document.mainform.grantees.value = granteeString;
			document.mainform.grantPriv.value = grantPrivString;

			for( var j=0; j<revokeId.length; j++ )
			{
				revokeeString += revokeId[j] + ";";
				revokePrivString += revokePriv[j] + ";";
			}
			document.mainform.revokees.value = revokeeString;
			document.mainform.revokePriv.value = revokePrivString;

			document.mainform.changeComment.value = commentChanged;
			document.mainform.cmd.value = "update";

			document.mainform.submit();
		}
	}

//-->
</SCRIPT>
</head>

<body bgcolor="FFFFFF" text="#000000"
	link="#FFFFFF" atext="#FFFF00" vlink="#FFFFFF"
	onMouseOver="hidePopupMenus();">

<form name="mainform" action="<%=webquerytool_cfg.getAppRoot()%>/TablesPage" method="post">
<input type="hidden" name="op" value="process">
<input type="hidden" name="cmd">
<input type="hidden" name="tablecreator" value="<%= webquerytool_tv.getCreator() %>">
<input type="hidden" name="tablename" value="<%= webquerytool_tv.getName() %>">
<input type="hidden" name="grantees">
<input type="hidden" name="grantPriv">
<input type="hidden" name="revokees">
<input type="hidden" name="revokePriv">
<input type="hidden" name="changeComment">

<% try { %>
<%@ include file="pageheader.inc" %>
<% } catch( Exception ex ) { %>
<%= ex %>
<% } %>

<TABLE width=90% align=center><TR><TD>

<table cellpadding=3 cellspacing=2 border=0 align=center width=100%>
<tr valign=top bgcolor="#6699CC" align=left>
	<td>
		<font size="-1" color="#FFFFFF" face="sans-serif">
			<b><%= jspInfo.get("NameHeader") %></b>
		</font>
	</td>

	<td>
		<font size="-1" color="#FFFFFF" face="sans-serif">
			<b><%= jspInfo.get("DescHeader") %></b>
		</font>
	</td>
</tr>

<tr bgcolor="#C0C0C0" align="left">
	<td>
		<font size="-1" color="#000000" face="sans-serif">
			&#160;<%= webquerytool_tv.getCreator() %>.<%= webquerytool_tv.getName() %>
		</font>
	</td>

	<td>
		<font size="-1" color="#000000" face="sans-serif">
			<TEXTAREA name=description
				rows=5 cols=38 wrap
				onChange="changecomment()"><%= webquerytool_tv.getTableDes() != null ? webquerytool_tv.getTableDes() : ""  %></TEXTAREA>
		</font>
	</td>
</tr>
</table>

<br>

<table cellpadding=3 cellspacing=2 border=0 align=center width=100%>
<tr valign=top bgcolor="#6699CC">
	<td>
		<table width=100% cellspacing=0 cellpadding=0 border=0 align=left>
		<TR>
			<TD align=left>
				<font size="-1" color="#FFFFFF" face="sans-serif">
					<b><%= jspInfo.get("IdHeader") %></b>
				</font>
			</TD>

			<TD align=right>
				<font size="-1" color="#FFFFFF" face="sans-serif">
					<input type=button name=grantbutton
						value="<%= jspInfo.get("GrantButton") %>"
						style="font-size:12"
						style="font-color:000000"
						style="background:C0C0C0"
						onClick="grantToId();">

					<input type=button name=revokebutton
						value="<%= jspInfo.get("RevokeButton") %>"
						style="font-size:12"
						style="font-color:000000"
						style="background:C0C0C0"
						onClick="revokeFromId();">
				</font>
			</TD>
		</TR>
		</table>
	</td>
</tr>

<tr valign=top bgcolor="#C0C0C0">
	<td align=center>
		<font size="-1" color="#000000" face="sans-serif">
			<select size=1 name="idList">
<%	 for( int i=0; i<uc.getAliasList().size(); i++ ) { %>
				<option value="<%= uc.getAliasList().elementAt(i) %>">
					<%= uc.getAliasList().elementAt(i) %>
				</option>
<%	 } %>
			</select>

			&nbsp; &nbsp;

			<input type=checkbox name="grantOption">
				<%= jspInfo.get("WithGrant") %>

			&nbsp; &nbsp;

			<input type=button
				name="addnewid" value="<%= jspInfo.get("AddIdButton") %>"
				style="font-size:12"
				style="font-color:000000"
				style="background:C0C0C0"
				onClick="addSqlId()">

			<input type=text name="newid" size=7>
		</font>
	</td>
</tr>
</table>

<br>

<table cellpadding=3 cellspacing=2 border=0 align=center width=100%>
<tr valign=top bgcolor="#6699CC">
	<td align=left>
		<font size="-1" color="#FFFFFF" face="sans-serif">
			<b><%= jspInfo.get("PrivHeader") %></b>
		</font>
	</td>

	<td align=left>
		<font size="-1" color="#FFFFFF" face="sans-serif">
			<b><%= jspInfo.get("GrantHeader") %></b>
		</font>
	</td>
</tr>

<tr valign=top bgcolor="#C0C0C0" align="center">
	<td>
		<font size="-1" color="#000000" face="sans-serif">
		<select name="privList" size=9 multiple
			onChange="displayGrantee()">
			<option value="0">ALTER</option>
			<option value="2">DELETE</option>
			<option value="3">INDEX</option>
			<option value="4">INSERT</option>
			<option value="6">SELECT</option>
			<option value="7">UPDATE</option>
			<option value="a">[<%= msgMgr.get( "allPerms" ) %>]</option>
		</select>
		</font>
	</td>

	<td>
		<font size="-1" color="#000000" face="sans-serif">
		<select name="grantList" size=9
			onChange="changeSqlId();">
			<option value=-1>
				&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
				&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
			</option>
		</select>
		</font>
	</td>
</tr>
</table>

</TD></TR></TABLE>

</form>

<script language="JavaScript">
<!--
	if( <%= webquerytool_ui.getReloadMenu() %> )
		window.top.HeaderFrame.menuRe( 'Menu', 'refresh', '');
//-->
</script>

</body>

</html>
