<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<%@ page import="java.util.Enumeration" %>
<%@ page import="java.util.Locale" %>
<%@ page import="java.text.Collator" %>
<%@ page import="java.text.CollationKey" %>

<%@ page import="com.ibm.db2.cwq.util.UserConnection" %>
<%@ page import="com.ibm.db2.cwq.msgs.JspChartWizPage" %>
<%@ page import="com.rocketsoftware.svg.charts.MetaData.MetaData" %>
<%@ page import="com.rocketsoftware.util.MsgMgr" %>

<jsp:useBean id="webquerytool_cfg" class="com.ibm.db2.cwq.util.Config" scope="session"/>
<jsp:useBean id="webquerytool_user" class="com.ibm.db2.cwq.util.User" scope="session"/>
<jsp:useBean id="webquerytool_ui" class="com.ibm.db2.cwq.util.UI" scope="session"/>
<jsp:useBean id="cwqChartMd" class="com.rocketsoftware.svg.charts.MetaData.MetaData" scope="session"/>

<%!	
	public static String getStortedColorList(
		MetaData cwqChartMd,
		MsgMgr msgMgr,
		Locale locale
		)
	{
		String retval = new String();
		String k = null;
		String key = null;

		Collator collator = Collator.getInstance( locale );
		
		// obtain all font colors
		Enumeration e = cwqChartMd.GetColorList();
		Vector ev = new Vector();
		Enumeration ek = cwqChartMd.GetNlsColorKeyList();
		Vector ekv = new Vector();
		while( e.hasMoreElements() )
		{
			ev.add( (String) e.nextElement() );
			ekv.add( msgMgr.get( (String) ek.nextElement() ) );
		}

		// sort
		String[] keys = new String[ ev.size() ];
		CollationKey[] collatorKeys = new CollationKey[ ekv.size() ];
		for( int i=0; i<ekv.size(); i++ )
		{
			keys[i] = (String) ev.elementAt( i );
			collatorKeys[i] = collator.getCollationKey( (String) ekv.elementAt( i ) );
		}

		for( int i=0; i<collatorKeys.length; i++ )
		{
			for( int j=i; j<collatorKeys.length; j++ )
			{
				if( collatorKeys[i].compareTo( collatorKeys[j] ) > 0 ) 
				{
					CollationKey temp = collatorKeys[j];
					collatorKeys[j] = collatorKeys[i];
					collatorKeys[i] = temp;
					
					String tkey = keys[j];
					keys[j] = keys[i];
					keys[i] = tkey;
				}
			}
		}

		// generate html option list
		for( int i=0; i<collatorKeys.length; i++ )
		{
			String sel = new String();
			if( cwqChartMd.GetTitleColor().equals( keys[i] ) )
				sel = "selected";
				
			retval += "<option value=\"" + keys[i] +"\" " +sel +">";
			retval += collatorKeys[i].getSourceString();
			retval += "</option>\n";
		}
					
	    return retval;
	}
%>

<%
    response.setHeader("Pragma", "No-cache");
    response.setHeader("Cache-Control", "no-cache");
    response.setDateHeader("Expires",0);

	MsgMgr msgMgr = new MsgMgr(
		"com.ibm.db2.cwq.nls.ChartWizPageJSP",
		request.getLocale()
	);

	MsgMgr headerMsgMgr = new MsgMgr(
		"com.ibm.db2.cwq.nls.HeaderPageJSP",
		request.getLocale()
	);

	UserConnection uc = webquerytool_user.getConnection(
		webquerytool_user.getCurrentCon()
	);


	JspChartWizPage jspInfo = new JspChartWizPage();
	jspInfo.setPage( "export/chartOptions.jsp" );
	jspInfo.setLoc( request.getLocale() );
	
	Enumeration e = null;
	Enumeration ek = null;
%>

<!-- All rights reserved. Licensed Materials Property of IBM          -->
<!-- Note to US Government users                                      -->
<!-- Documentation related to restricted rights                       -->
<!-- Use, duplication or disclosure is subject to restrictions        -->
<!-- set forth in GSA ADP Schedule with IBM Corp.                     -->
<!--This page may contain other proprietary notices and copyright     -->
<!--information, the terms of which must be observed and followed.    -->

<HTML>

<head>
	<title> <%= jspInfo.getTitle() %> </title>

	<base href="<%= webquerytool_cfg.getWebRoot(request) %>">

	<META name="COPYRIGHT"
		content="IBM Corporation (c) 1999-2002, All Rights Reserved">
	<META name="GENERATOR"
		content="IBM Web Query Tool (c) 1999-2002, All Rights Reserved">

	<SCRIPT language="JavaScript" src="webquery.js">
	</SCRIPT>

	<SCRIPT language="JavaScript">
	<!--
		function goChart( page )
		{
			document.forms[0].cmd.value = page;

			document.forms[0].target = "_TOP";
			document.forms[0].submit();
		}

		function goCancel( page )
		{
			document.forms[0].cmd.value = page;

			document.forms[0].target = "";
			document.forms[0].submit();
		}

		function goChartPage( page )
		{
			document.forms[0].nextpage.value = page;
			document.forms[0].cmd.value = "switchpage";

			document.forms[0].target = "";
			document.forms[0].submit();
		}

		function goRefreshChart()
		{
			document.forms[0].cmd.value = "refresh";

			document.forms[0].target = "";
			document.forms[0].submit();
		}
	//-->
	</SCRIPT>

</head>

<body bgcolor="FFFFFF" text="#000000"
	link="#FFFFFF" alink="#FFFF00" vlink="#FFFFFF"
	onMouseOver="hidePopupMenus();">

<form method=post action="<%=webquerytool_cfg.getAppRoot()%>/ChartWorkbench">

<input type=hidden name="page" value="chartOptions">
<input type=hidden name="nextpage">
<input type=hidden name="op" value="process">
<input type=hidden name="cmd" value="">

<% try { %>
<%@ include file="../pageheader.inc" %>
<% } catch( Exception ex ) { %>
<%= ex %>
<% } %>	

<TABLE width=90% align=center><TR><TD>

	<%	// -------------------------------------------
		// XSL Options
		// ------------------------------------------- %>

	<table border=0 cellpadding=2 cellspacing=1 align=center bgcolor="#FFFFFF" width=100%>
	<tr bgcolor="#6699CC">
		<td>
			<font size=-1 color="#FFFFFF" face="sans-serif"> <b>
			<%= msgMgr.get( "preview" ) %>
			</b> </font>
		</td>
		<td>
			<font size=-1 color="#FFFFFF" face="sans-serif"> <b>
			<%= msgMgr.get( "options" ) %>
			</b> </font>
		</td>
	</tr>


	<tr valign=top bgcolor="#C0C0C0">
		<td valign=middle align=center>
			<font size=-1 color="#FFFFFF" face="sans-serif">

			<EMBED SRC="<%=webquerytool_cfg.getAppRoot()%>/ChartWorkbench?cmd=genchart" NAME="CWQSVGEmbed"
				WIDTH="160" HEIGHT="120" TYPE="image/svg+xml"
				PLUGINSPAGE="http://www.adobe.com/svg/viewer/install/">
			
			<br><br>
			
			<input type=button
				onClick="goRefreshChart();"
				style="font-size:12" style="font-color:000000" style="background:C0C0C0"
				value="<%= msgMgr.get( "updateButton" ) %>">
			
			<br><br>
				
			<%= msgMgr.get( "previewRequires" ) %>
			</font>
		</td>

		<td>
			<TABLE bgcolor="#FFFFFF" width=100% cellspacing="0" cellpadding="0" border="0">
			<TR bgcolor="#C0C0C0">
				<TD align="left" colspan=2>
					<font size=-1 color="#000000" face="sans-serif">
					<b>
					<%= msgMgr.get( "title" ) %>:
					</b>
					</font>
				</TD>
			</TR>
			<TR bgcolor="#C0C0C0">
				<TD align="right">
					<font size=-1 color="#000000" face="sans-serif">
					<%= msgMgr.get( "fontFace" ) %>:
					</font>
				</TD>
				<TD>
					<font size=-1 color="#000000" face="sans-serif">
					<select name=titleFont size=1>
				<%	e = cwqChartMd.GetFontList();
					ek = cwqChartMd.GetNlsFontKeyList();
					while( e.hasMoreElements() )
					{
						String k = (String) e.nextElement();
						String key = (String) ek.nextElement();
				%>
						<option value="<%= k %>" <%= cwqChartMd.GetTitleFont().equals(k) ? "selected" : "" %>>
							<%= msgMgr.get( key ) %>
						</option>
				<%	} %>
					</select>
					</font>
				</TD>
			</TR>
	
			<TR bgcolor="#C0C0C0">
				<TD align="right">
					<font size=-1 color="#000000" face="sans-serif">
					<%= msgMgr.get( "fontColor" ) %>:
					</font>
				</TD>
				<TD>
					<font size=-1 color="#000000" face="sans-serif">
					<select name=titleFontColor size=1>
					<%= getStortedColorList( cwqChartMd, msgMgr, request.getLocale() ) %>
					</select>
					</font>
				</TD>
			</TR>
			</TABLE>
			
			<br>
			
			<%	// -------------------------------------------
				// background
				// ------------------------------------------- %>
			<TABLE bgcolor="#FFFFFF" width=100% cellspacing="0" cellpadding="0" border="0">
			<TR bgcolor="#C0C0C0">
				<TD align="left" colspan=2>
					<font size=-1 color="#000000" face="sans-serif">
					<b>
					<%= msgMgr.get( "background" ) %>:
					</b>
					</font>
				</TD>
			</TR>
			<TR bgcolor="#C0C0C0">
				<TD align="right">
					<font size=-1 color="#000000" face="sans-serif">
					<%= msgMgr.get( "backgroundColor" ) %>:
					</font>
				</TD>
				<TD>
					<font size=-1 color="#000000" face="sans-serif">
					<select name=bgColor size=1>
					<%= getStortedColorList( cwqChartMd, msgMgr, request.getLocale() ) %>
					</select>
					</font>
				</TD>
			</TR>
			</TABLE>

			<br>
			
			<%	// -------------------------------------------
				// X axis
				// ------------------------------------------- %>
			<TABLE bgcolor="#FFFFFF" width=100% cellspacing="0" cellpadding="0" border="0">
			<TR bgcolor="#C0C0C0">
				<TD align="left" colspan=2>
					<font size=-1 color="#000000" face="sans-serif">
					<b>
					<%= msgMgr.get( "xaxis" ) %>:
					</b>
					</font>
				</TD>
			</TR>
			<TR bgcolor="#C0C0C0">
				<TD align="right">
					<font size=-1 color="#000000" face="sans-serif">
					<%= msgMgr.get( "fontFace" ) %>:
					</font>
				</TD>
				<TD>
					<font size=-1 color="#000000" face="sans-serif">
					<select name=xAxisFont size=1>
				<%	e = cwqChartMd.GetFontList();
					ek = cwqChartMd.GetNlsFontKeyList();
					while( e.hasMoreElements() )
					{
						String k = (String) e.nextElement();
						String key = (String) ek.nextElement();
				%>
						<option value="<%= k %>" <%= cwqChartMd.Xaxis.GetFont().equals(k) ? "selected" : "" %>>
							<%= msgMgr.get( key ) %>
						</option>
				<%	} %>
					</select>
					</font>
				</TD>
			</TR>

			<TR bgcolor="#C0C0C0">
				<TD align="right">
					<font size=-1 color="#000000" face="sans-serif">
					<%= msgMgr.get( "fontColor" ) %>:
					</font>
				</TD>
				<TD>
					<font size=-1 color="#000000" face="sans-serif">
					<select name=xAxisFontColor size=1>
					<%= getStortedColorList( cwqChartMd, msgMgr, request.getLocale() ) %>
					</select>
					</font>
				</TD>
			</TR>
			</TABLE>

			<br>
			
			<%	// -------------------------------------------
				// y-axis
				// ------------------------------------------- %>
			<TABLE bgcolor="#FFFFFF" width=100% cellspacing="0" cellpadding="0" border="0">
			<TR bgcolor="#C0C0C0">
				<TD align="left" colspan=2>
					<font size=-1 color="#000000" face="sans-serif">
					<b>
					<%= msgMgr.get( "yaxis" ) %>:
					</b>
					</font>
				</TD>
			</TR>
			<TR bgcolor="#C0C0C0">
				<TD align="right">
					<font size=-1 color="#000000" face="sans-serif">
					<%= msgMgr.get( "fontFace" ) %>:
					</font>
				</TD>
				<TD>
					<font size=-1 color="#000000" face="sans-serif">
					<select name="yAxisFont" size="1">
				<%	e = cwqChartMd.GetFontList();
					ek = cwqChartMd.GetNlsFontKeyList();
					while( e.hasMoreElements() )
					{
						String k = (String) e.nextElement();
						String key = (String) ek.nextElement();
				%>
						<option value="<%= k %>" <%= cwqChartMd.Yaxis.GetFont().equals(k) ? "selected" : "" %>>
							<%= msgMgr.get( key ) %>
						</option>
				<%	} %>
					</select>
					</font>
				</TD>
			</TR>

			<TR bgcolor="#C0C0C0">
				<TD align="right">
					<font size=-1 color="#000000" face="sans-serif">
					<%= msgMgr.get( "fontColor" ) %>:
					</font>
				</TD>
				<TD>
					<font size=-1 color="#000000" face="sans-serif">
					<select name=yAxisFontColor size=1>
					<%= getStortedColorList( cwqChartMd, msgMgr, request.getLocale() ) %>
					</select>
					</font>
				</TD>
			</TR>
			</TABLE>
		</td>
	</tr>
	</table>

</TD></TR></TABLE>

</form>

<script language="JavaScript">
<!--
	if (<%= webquerytool_ui.getReloadMenu() %>)
		window.top.HeaderFrame.menuRe( 'Menu', 'refresh', '');
//-->
</script>

</body>

</html>