<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<%@ page import="com.rocketsoftware.util.MsgMgr" %>
<%@ page import="java.util.*" %>
<%@ page import="com.ibm.db2.cwq.util.UserConnection" %>

<jsp:useBean id="webquerytool_cfg" class="com.ibm.db2.cwq.util.Config" scope="session"/>
<jsp:useBean id="webquerytool_user" class="com.ibm.db2.cwq.util.User" scope="session"/>
<jsp:useBean id="webquerytool_ui" class="com.ibm.db2.cwq.util.UI" scope="session"/>
<jsp:useBean id="cwqSqlPa" class="com.ibm.db2.cwq.sql.SqlPa" scope="session"/>

<%
    response.setHeader("Pragma", "No-cache");
    response.setHeader("Cache-Control", "no-cache");
    response.setDateHeader("Expires",0);

	MsgMgr msgMgr = new MsgMgr(
		"com.ibm.db2.cwq.nls.SQLPAOpt.jsp",
		request.getLocale()
	);

	MsgMgr headerMsgMgr = new MsgMgr(
		"com.ibm.db2.cwq.nls.HeaderPageJSP",
		request.getLocale()
	);

	UserConnection uc = webquerytool_user.getConnection(
		webquerytool_user.getCurrentCon()
	);


    // -----------------------------------------
    // Header
    String pageName = "sql/SQLPAOpt.jsp";

    String headerTitle = "SQL/PA Options";

    boolean headerShowMsg = true;
    boolean headerChangeCon = true;
    boolean headerQuickHelp = true;

    // ---------------------------------------
    // Left Menu
    String[] headerLeft =
    	{
    		"Save", "go('sqlpaoptions')",
    		"Defaults", "go('sqlpadefaults')",
    		"Cancel", "go('sqlpacancel')"
    	};

    // ---------------------------------------
    // Right Menu
    String headerRightTitle = "";

    String[] headerRight = new String[0];

    // ---------------------------------------
    // Quick Help
	String headerHelpText =
		"Specify the options for SQL/PA. "
		+"<p>"
		+"Click <i>Save</i> to save your options and continue."
		+"Click <i>Cancel</i> to return the the query."
		+"Click <i>Defaults</i> to reset options to the default values.";

%>

<!-- All rights reserved. Licensed Materials Property of IBM          -->
<!-- Note to US Government users                                      -->
<!-- Documentation related to restricted rights                       -->
<!-- Use, duplication or disclosure is subject to restrictions        -->
<!-- set forth in GSA ADP Schedule with IBM Corp.                     -->
<!--This page may contain other proprietary notices and copyright     -->
<!--information, the terms of which must be observed and followed.    -->

<HTML>

<head>
	<title> SQL/PA Options </title>

	<base href="<%= webquerytool_cfg.getWebRoot(request) %>">

	<META name="COPYRIGHT"
		content="IBM Corporation (c) 1999-2002, All Rights Reserved">
	<META name="GENERATOR"
		content="IBM Web Query Tool (c) 1999-2002, All Rights Reserved">

	<SCRIPT language="JavaScript" src="webquery.js">
	</SCRIPT>

	<SCRIPT language="JavaScript" src="sql/sqlvarsmenu.js">
	</SCRIPT>

	<SCRIPT language="JavaScript">
	<!--
		var totalMenus = <%= webquerytool_ui.getSQLParam().size() %>;
	//-->
	</SCRIPT>
</head>

<body bgcolor="FFFFFF" text="#000000"
	link="#FFFFFF" alink="#FFFF00" vlink="#FFFFFF"
	onMouseOver="hidePopupMenus();">

<form method=post action="<%=webquerytool_cfg.getAppRoot()%>/SQLText">

<input type="hidden" name="op" value="process">
<input type="hidden" name="cmd" value="">
<input type="hidden" name="page" value="sqlpaoptions">

<% try { %>
<%@ include file="../header.inc" %>
<% } catch( Exception ex ) { %>
<%= ex %>
<% } %>

<table border=0 cellpadding=0 cellspacing=0 align=center width=100%>
<tr>
	<td>
		<table cellspacing=2 cellpadding=2 border=0 align=center width=90%>
		<tr>
			<TD bgcolor="#6699CC" align=center colspan=2>
				<font size=-1 face="arial,sans-serif" color="#FFFFFF">
				<b>Options</b>
				</font>
			</TD>
		</tr>

		<tr>
			<TD valign=top align=left bgcolor="#C0C0C0" width=50%>
				<TABLE border=0 border=0 cellpadding=2 cellspacing=0>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<b>Version:</b>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
						<SELECT name=version size=1>
						<%= cwqSqlPa.getHTMLSelect( cwqSqlPa.getParamVersion(), cwqSqlPa.PARAM_VERSION ) %>
						</SELECT>
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<b>Reports:</b>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
						STP
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<b>Storage:</b>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
						<SELECT name=storage size=1>
						<%= cwqSqlPa.getHTMLSelect( cwqSqlPa.getParamStorage(), cwqSqlPa.PARAM_STORAGE ) %>
						</SELECT>
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<b>Storage:</b>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
							<nobr><INPUT type=text size=5 name=newseek value="<%= cwqSqlPa.getParamNewseek() %>"> Seek (sec)</nobr>
							<br>
							<nobr><INPUT type=text size=5 name=newrota value="<%= cwqSqlPa.getParamNewrota() %>"> Rotation Delay (sec)</nobr>
							<br>
							<nobr><INPUT type=text size=5 name=newxfer value="<%= cwqSqlPa.getParamNewxfer() %>"> Transfer Rate (KB/sec)</nobr>
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<b>Class 1<BR>CPU Only:</b>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
						<SELECT name=class size=1>
						<%= cwqSqlPa.getHTMLSelect( cwqSqlPa.getParamClass(), cwqSqlPa.PARAM_CLASS ) %>
						</SELECT>
						</font>
					</TD>
				</TR>
				</TABLE>

				</font>
			</TD>

			<TD valign=top align=left bgcolor="#C0C0C0" width=50%>
				<TABLE border=0 align=center>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<B>Precise:</B>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
						<SELECT name=precise size=1>
						<%= cwqSqlPa.getHTMLSelect( cwqSqlPa.getParamPrecise(), cwqSqlPa.PARAM_PRECISE ) %>
						</SELECT>
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<B>BufferPool Hit Ratio:</B>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
							<INPUT type=text size=5 name=buffhit value="<%= cwqSqlPa.getParamBuffhit() %>"> %
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<B>HipperPool Hit Ratio:</B>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
							<INPUT type=text size=5 name=hpoolrd value="<%= cwqSqlPa.getParamHpoolrd() %>"> %
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<B>Attach Method:</B>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
						<SELECT name=connect size=1>
						<%= cwqSqlPa.getHTMLSelect( cwqSqlPa.getParamConnect(), cwqSqlPa.PARAM_CONNECT ) %>
						</SELECT>
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<B>Name Qualifier:</B>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
							<INPUT type=text size=5 name=qualify value="<%= cwqSqlPa.getParamQualify() %>">
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<B>Parallel Degrees:</B>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
						<SELECT name=degrees size=1>
						<%= cwqSqlPa.getHTMLSelect( cwqSqlPa.getParamDegrees(), cwqSqlPa.PARAM_DEGREES ) %>
						</SELECT>
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<b>Include Overhead:</b>
						</font>
					</TD>
					<TD>
						<font face="arial,sans-serif" size="-1">
						<SELECT name=overhead size=1>
						<%= cwqSqlPa.getHTMLSelect( cwqSqlPa.getParamOverhead(), cwqSqlPa.PARAM_OVERHEAD ) %>
						</SELECT>
						</font>
					</TD>
				</TR>
				<TR valign=top>
					<TD align=right>
						<font face="arial,sans-serif" size="-1">
						<b>SQL/PA Debug Trace:</b>
						</font>
					</TD>
					<TD align=left>
						<font face="arial,sans-serif" size="-1">
						<input type=checkbox name=debug <%= cwqSqlPa.isDebug() ? "CHECKED" : "" %>>
						</font>
					</TD>
				</TR>
				</TABLE>
			</TD>
		</tr>
		</table>
	</td>
</tr>
</table>

</form>


<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>

<script language="JavaScript">
<!--
	if (<%= webquerytool_ui.getReloadMenu() %>)
		window.top.HeaderFrame.menuRe( 'Menu', 'refresh', '');
//-->
</script>

</body>

</html>
